import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * All subclasses of this class will not be moved by the scrolling system, because they are menus.
 */
public class Menu extends Actor
{
    Button playButton;
    Button instructionsButton;
    private boolean buttonsPlaced;
    private static boolean isDone;
    Button menuButton;
    Instructions instructions;
    public Menu() 
    {
        playButton=new Button();
        instructionsButton=new Button();
        buttonsPlaced=false;
        isDone=false;
        menuButton=new Button();
        instructions=new Instructions();
    }
    public void act()
    {
        if(!buttonsPlaced)
        {
            place();
            buttonsPlaced=true;
        }
        detectClick();
    }
    public void place()
    {
        getWorld().addObject(playButton, 80, 250);
        playButton.setImage("play.png");
        getWorld().addObject(instructionsButton, 80, 285);
        instructionsButton.setImage("instructions.png");
    }
    public void detectClick()
    {
        if(Greenfoot.mouseClicked(instructionsButton))
        {
            getWorld().addObject(instructions, 255, 162);
            instructions.setImage("instructionsScreen.png");
            getWorld().addObject(menuButton, 440, 304);
            menuButton.setImage("back.png");
        }
        else if(Greenfoot.mouseClicked(playButton))
        {
            isDone=true;
            disappear();
        }
        else if(Greenfoot.mouseClicked(menuButton))
        {
            getWorld().removeObject(instructions);
            getWorld().removeObject(menuButton);
        }
    }
    public static boolean getIsDone()
    {
        return isDone;
    }
    public void disappear()
    {
        getWorld().removeObject(playButton);
        getWorld().removeObject(instructionsButton);
        getWorld().removeObject(this);
    }
}